Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Name:           beagle
Version:        0.3.9
Release:        1
Summary:        The Beagle Search Infrastructure
Group:          User Interface/Desktops
License:        LGPL
URL:            http://beagle-project.org/
Source0:        %{name}-%{version}.tar.bz2
Source1:	beagle-thunderbird-update.sh
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  mono-core-devel
BuildRequires:  mono-data mono-data-sqlite
BuildRequires:  gtk-sharp-gapi gtk-sharp-devel gnome-sharp-devel mono-web zip libexif-devel
BuildRequires:  gsf-sharp-devel
BuildRequires:  sqlite-devel
BuildRequires:  gmime-sharp
BuildRequires:  evolution-sharp-devel
BuildRequires:  libXScrnSaver-devel
BuildRequires:  gnome-vfs-devel
BuildRequires:  libgnome-devel
BuildRequires:  gtk2+-devel
BuildRequires:  librsvg-devel
BuildRequires:	PyGTK-devel
BuildRequires:	python-devel
BuildRequires:	libXt-devel
BuildRequires:	gettext
BuildRequires:	autoconf
BuildRequires:	perl-XML-Parser
Requires: 	sqlite
Requires: 	mono-core
Requires: 	zip unzip sed grep poppler-utils

Requires: 	gsf-sharp gtk-sharp gnome-sharp gmime-sharp mono-data

Requires(pre):  shadow

Patch3: beagle-0.3.9-spew.patch
Patch4: beagle-0.3.0-runuser.patch
Patch5: beagle-0.2.15.1-libdir.patch
Patch6: beagle-monodoc.patch
Patch7: beagle-0.3.8-epiphany.patch
#gmime-2.4
Patch8: beagle-0.3.9-gmime24.patch
#firefox 3.1
#Patch9: beagle-0.3.8-fx31.patch
#gnome-desktop
Patch10: beagle-0.3.9-libgnome-desktop-soname.patch
Patch11: beagle-0.3.9-openfix.patch

%define grefile /etc/gre.d/gre.conf

%description
A general infrastructure for making your data easy to find. 

%package gnome
Summary:	Beagle search system user interface for GNOME
Group:		User Interface/Desktops
Requires:	beagle = %{version}-%{release}
Requires:	gnome-desktop >= 2.25.0
Obsoletes:	beagle-gui
Provides:	beagle-gui

%description gnome
User interface for doing beagle searches

%package evolution
Summary:      	Beagle backend for evolution
Group:        	User Interface/Desktops
Requires:     	beagle = %{version}-%{release}
Requires: 	evolution-sharp

%description evolution
Beagle indexing backend for evolution

%package thunderbird
Summary:	Beagle backend for Thunderbird
Group:		User Interface/Desktops
Requires:	beagle = %{version}-%{release}
Requires:	thunderbird

%description thunderbird
Beagle backend for Thunderbird

%package firefox
Summary:	Beagle Indexer Extension for Firefox
Group:		User Interface/Desktops
Requires:	beagle = %{version}-%{release}

%description firefox
Beagle Indexer Extension for Firefox

%package devel
Summary:    Development files for the Beagle search infrastructure
Group:      Development/Libraries
# for /usr/lib/pkgconfig
Requires:   pkgconfig
# for /usr/lib/monodoc/
Requires:         monodoc
Requires(post):   monodoc
Requires(postun): monodoc

%description devel
The beagle-devel package contains documentation and other materials
that are useful when developing applications that use Beagle.

# firefox app id for beagle firefox extension
%define firefox_app_id \{ec8030f7-c20a-464f-9b0e-13a3a9e97384\}
%define firefox_ext_id \{fda00e13-8c62-4f63-9d19-d168115b11ca\}

%prep
%setup -q
%define _default_patch_fuzz 2
#%patch2 -p1 -b .crawl
%patch3 -p1 -b .spew
%patch4 -p1 -b .runuser
%patch5 -p1 -b .libdir
%patch6 -p1 -b .monodoc
%patch7 -p1 -b .epiphany
%patch8 -p1 -b .gmime-2.4
#%patch9 -p1 -b .firefox-3.1
%patch10 -p1 -b .gnome-desktop
%patch11 -p1 -b .open-fix

%build
export MONO_SHARED_DIR=%{_builddir}/%{?buildsubdir}
%configure --enable-wv1 --disable-googlebackends
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
export MONO_SHARED_DIR=%{_builddir}/%{?buildsubdir}

make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/var/cache/beagle/indexes

# don't autostart the search gui
rm -f $RPM_BUILD_ROOT/etc/xdg/autostart/beagle-search-autostart.desktop

# firefox extension
mkdir -p $RPM_BUILD_ROOT%{_libdir}/mozilla/extensions/%{firefox_app_id}/%{firefox_ext_id}
unzip firefox-extension/beagle.xpi \
-d $RPM_BUILD_ROOT%{_libdir}/mozilla/extensions/%{firefox_app_id}/%{firefox_ext_id}

# thunderbird extension
mkdir -p  $RPM_BUILD_ROOT%{_libdir}/beagle/thunderbird
unzip thunderbird-extension/beagle.xpi  -d $RPM_BUILD_ROOT%{_libdir}/beagle/thunderbird
install -D -p -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/beagle/beagle-thunderbird-update.sh

desktop-file-install --vendor gnome --delete-original	\
  --dir $RPM_BUILD_ROOT%{_datadir}/applications			\
  $RPM_BUILD_ROOT%{_datadir}/applications/beagle-search.desktop

desktop-file-install --vendor gnome --delete-original	\
  --dir $RPM_BUILD_ROOT%{_datadir}/applications			\
  --add-category X-GNOME-SystemSettings			\
  --remove-category Utility					\
  $RPM_BUILD_ROOT%{_datadir}/applications/beagle-settings.desktop

echo "NoDisplay=true" >> $RPM_BUILD_ROOT%{_datadir}/applications/gnome-beagle-search.desktop

sed -i -e 's@Icon=tango-system-search@Icon=gnome-search-tool@' $RPM_BUILD_ROOT%{_datadir}/applications/gnome-beagle-search.desktop

%find_lang %{name}

find $RPM_BUILD_ROOT -name '*.la' -exec rm -f {} ';'
find $RPM_BUILD_ROOT -name '*.a' -exec rm -f {} ';'

%{__sed} -i 's/\r//' $RPM_BUILD_ROOT%{_libdir}/mozilla/extensions/%{firefox_app_id}/%{firefox_ext_id}/chrome/locale/zh-CN/contents.rdf

#Fix bogus permissions
find $RPM_BUILD_ROOT -name '*.dll' -exec chmod a+x {} ';'
find $RPM_BUILD_ROOT -name '*.exe' -exec chmod a+x {} ';'
find $RPM_BUILD_ROOT -name '*.py' -exec chmod a+x {} ';'
find $RPM_BUILD_ROOT -name '*.js' -exec chmod a-x {} ';'
find $RPM_BUILD_ROOT -name '*.rdf' -exec chmod a-x {} ';'
find $RPM_BUILD_ROOT -name '*.xul' -exec chmod a-x {} ';'
find $RPM_BUILD_ROOT -name '*.dtd' -exec chmod a-x {} ';'
find $RPM_BUILD_ROOT -name '*.css' -exec chmod a-x {} ';'

%pre
%define beagle_user_uid 58

#only create user if it doesn't exists
%{_bindir}/id -u beaglidx 1>/dev/null 2>&1
if [ $? -ne 0 ]; then
  %{_sbindir}/groupadd -g %{beagle_user_uid} -r beaglidx 2> /dev/null || :
  %{_sbindir}/useradd -r -u %{beagle_user_uid} -s /sbin/nologin -c "User for Beagle indexing" -d /var/cache/beagle -g beaglidx beaglidx 2> /dev/null || :
fi
exit 0

%preun
if [ -f %{_libdir}/beagle/beagle-plugin-path ]; then
  old=`cat %{_libdir}/beagle/beagle-plugin-path`
  rm -rf $old
  rm -rf  %{_libdir}/beagle/beagle-plugin-path 
fi

%post 
if [ -f %{_libdir}/beagle/beagle-plugin-path ]; then
  old=`cat %{_libdir}/beagle/beagle-plugin-path`
  rm -rf $old
  rm -rf  %{_libdir}/beagle/beagle-plugin-path 
fi

%post devel
if [ -x %{_bindir}/monodoc ]; then
  %{_bindir}/monodoc --make-index > /dev/null
fi

%postun devel
if [ "$1" = "0" -a -x %{_bindir}/monodoc ]; then
  %{_bindir}/monodoc --make-index > /dev/null
fi

#############################
# thunderbird extension hacks
# copied from mugshot to deal with versioned 
# thunderbird dirs
%post thunderbird
%{_datadir}/beagle/beagle-thunderbird-update.sh install

%preun thunderbird
%{_datadir}/beagle/beagle-thunderbird-update.sh remove

%postun thunderbird
if [ "$1" != 0 ] ; then
  test -x %{_datadir}/beagle/beagle-thunderbird-update.sh && %{_datadir}/beagle/beagle-thunderbird-update.sh install
fi

%triggerin thunderbird -- thunderbird
%{_datadir}/beagle/beagle-thunderbird-update.sh install

%triggerun thunderbird -- thunderbird
%{_datadir}/beagle/beagle-thunderbird-update.sh remove

%triggerpostun thunderbird -- thunderbird
if [ "$1" != 0 ] ; then
  test -x %{_datadir}/beagle/beagle-thunderbird-update.sh && %{_datadir}/beagle/beagle-thunderbird-update.sh install
fi

# thunderbird extension hacks

%clean
rm -rf $RPM_BUILD_ROOT

%files -f %{name}.lang
%defattr(-,root,root,-)
%doc COPYING README
%{_sysconfdir}/cron.daily/*
%{_bindir}/beagled
%{_bindir}/blocate
%{_bindir}/beagle-config
%{_bindir}/beagle-doc-extractor
%{_bindir}/beagle-extract-content
%{_bindir}/beagle-index-info
%{_bindir}/beagle-info
%{_bindir}/beagle-ping
%{_bindir}/beagle-query
%{_bindir}/beagle-shutdown
%{_bindir}/beagle-static-query
%{_bindir}/beagle-status
%{_sbindir}/*
%{_libdir}/beagle/
%dir %{_sysconfdir}/beagle
%dir %{_sysconfdir}/beagle/config-files
%dir %{_sysconfdir}/beagle/crawl-rules
%config(noreplace) %{_sysconfdir}/beagle/blocate.conf
%config(noreplace) %{_sysconfdir}/beagle/config-files/*
%config(noreplace) %{_sysconfdir}/beagle/crawl-rules/*
%config(noreplace) %{_sysconfdir}/beagle/*.xml
%{_sysconfdir}/beagle/external-filters.xml.sample
%exclude %{_libdir}/beagle/Backends/Thunder*
%exclude %{_libdir}/beagle/Backends/Evolution*
%exclude %{_datadir}/beagle/beagle-thunderbird-update.sh
%exclude %{_libdir}/beagle/thunderbird/
%exclude %{_libdir}/beagle/libbeagleuiglue*
%exclude %{_libdir}/beagle/UiUtil.dll*
%exclude %{_libdir}/beagle/ImLogViewer.exe*
%exclude %{_libdir}/beagle/Settings.exe*
%exclude %{_libdir}/beagle/Beagle.Search.*
%{_datadir}/beagle
%{_mandir}/*/*
%dir %attr(-,beaglidx,beaglidx) /var/cache/beagle
%dir %attr(-,beaglidx,beaglidx) /var/cache/beagle/indexes
%{_sysconfdir}/xdg/autostart/beagled-autostart.desktop

%files firefox
%defattr(-, root, root,-)
%{_libdir}/mozilla/extensions/%{firefox_app_id}/

%files thunderbird
%defattr(-, root, root,-)
%{_datadir}/beagle/beagle-thunderbird-update.sh
%{_libdir}/beagle/Backends/ThunderbirdBackends.dll*
%{_libdir}/beagle/thunderbird/

#%files epiphany
#%defattr(-, root, root,-)
#%{_libdir}/epiphany/

%files gnome
%defattr(-, root, root,-)
%{_bindir}/beagle-imlogviewer
%{_bindir}/beagle-search
%{_bindir}/beagle-settings
%{_libdir}/beagle/UiUtil.dll*
%{_libdir}/beagle/ImLogViewer.exe*
%{_libdir}/beagle/Settings.exe*
%{_libdir}/beagle/libbeagleuiglue*
%{_libdir}/beagle/Beagle.Search.*
%{_datadir}/applications/*

%files evolution
%defattr(-, root, root)
%{_libdir}/beagle/Backends/EvolutionBackends.dll*

%files devel
%defattr(-, root, root)
%doc %{_libdir}/monodoc/sources/beagle-docs.*
%{_libdir}/pkgconfig/beagle*.pc

%changelog
* Fri Apr 03 2009 Christian Metzen <metzench@ccux-linux.de> 0.3.9-1
- Version update
* Tue Dec 11 2007 Christian Metzen <metzench@ccux-linux.de> 0.3.1-1
- Version update
* Mon Dec 03 2007 Christian Metzen <metzench@ccux-linux.de> 0.3.0-1
- Version update
* Tue Oct 09 2007 Karsten Brockmann <arcam@ccux-linux.de> 0.2.18-2
- refined Requires list
* Mon Oct 08 2007 Christian Metzen <metzench@ccux-linux.de> 0.2.18-1
- Version update
* Tue Apr 03 2007 Christian Metzen <metzench@ccux-linux.de> 0.2.16.2-2
- fix in user/group addition
* Tue Apr 03 2007 Christian Metzen <metzench@ccux-linux.de> 0.2.16.2-1
- Initial release 
